<?php
function GetFolders( $resourceType, $currentFolder )
	{
	$sServerDir = ServerMapFolder( $resourceType, $currentFolder, 'GetFolders' );
	$aFolders = array(  );
	$oCurrentFolder = opendir( $sServerDir );
	while ( $sFile = readdir( $oCurrentFolder ) ) {
		if ( $sFile != '.' && $sFile != '..' && is_dir( $sServerDir.$sFile ) )
		$aFolders[] = '<Folder name="'.ConvertToXmlAttribute( $sFile ).'" />';
		}
	closedir( $oCurrentFolder );
	echo '<Folders>';
	natcasesort( $aFolders );
	foreach ( $aFolders as $sFolder )
	echo $sFolder;
	echo '</Folders>';
	}

function GetFoldersAndFiles( $resourceType, $currentFolder ) {
	global $Config;
	$sServerDir = ServerMapFolder( $resourceType, $currentFolder, 'GetFoldersAndFiles' );
	$sCurrentPath = GetUrlFromPath( $resourceType, $currentFolder, 'GetFoldersAndFiles' );
	$aFolders = array(  );
	$aFiles = array(  );
	$oCurrentFolder = opendir( $sServerDir );
	while ( $sFile = readdir( $oCurrentFolder ) )
		{
		if ( $sFile != '.' && $sFile != '..' ) {
			if ( is_dir( $sServerDir.$sFile ) ) {
				$aFolders[] = '<Folder name="'.ConvertToXmlAttribute( $sFile ).'" size="'.filemanager_dirsize( $sServerDir.$sFile ).'"/>';
				}
			else {
				$iFileSize = @filesize( $sServerDir.$sFile );
				if ( ! $iFileSize ) $iFileSize = 0;
				if ( $iFileSize > 0 ) $iFileSize = filemanager_size( $iFileSize );
				if ( $resourceType == 'Image' && $Config['ThumbList'] ) {
					$new = filemanager_getthumbname( $currentFolder.$sFile );
					if ( file_exists( CombinePaths( $_SERVER['DOCUMENT_ROOT'].GetResourceTypePath( 'ImageThumb', 'GetFoldersAndFiles' ), $new ) ) )
						$t = CombinePaths( GetResourceTypePath( 'ImageThumb', 'GetFoldersAndFiles' ), $new );
					else
						$t = 'X';
					list( $w, $h ) = getimagesize( $sServerDir.$sFile );
					$add = 'thumb="'.ConvertToXmlAttribute( $t ).'" width="'.$w.'" height="'.$h.'"';
					}
				else
					$add = '';
				$aFiles[] = '<File name="'.ConvertToXmlAttribute( $sFile ).'" size="'.$iFileSize.'" '.$add.'/>';
				}
			}
		}
	natcasesort( $aFolders );
	echo '<Folders>';
	foreach ( $aFolders as $sFolder ) echo $sFolder;
	echo '</Folders>';
	natcasesort( $aFiles );
	echo '<Files>';
	foreach ( $aFiles as $sFiles ) echo $sFiles;
	echo '</Files>';
	}

function CreateFolder( $resourceType, $currentFolder ) {
	if ( ! isset( $_GET ) ) global $_GET;
	$sErrorNumber = '0';
	$sErrorMsg = '';
	if ( isset( $_GET['NewFolderName'] ) ) {
		$sNewFolderName = filemanager_translit( $_GET['NewFolderName'] );
		$sNewFolderName = SanitizeFolderName( $sNewFolderName );
		if ( strpos( $sNewFolderName, '..' ) !== FALSE ) {
			$sErrorNumber = '102';
			}
		else {
			$sServerDir = ServerMapFolder( $resourceType, $currentFolder, 'CreateFolder' );
			if ( is_writable( $sServerDir ) ) {
				$sServerDir .= $sNewFolderName;
				$sErrorMsg = CreateServerFolder( $sServerDir );
				switch ( $sErrorMsg ) {
					case '':
						$sErrorNumber = '0';
						break;
					case 'Invalid argument':
					case 'No such file or directory' :
						$sErrorNumber = '102';
						break;
					default:
						$sErrorNumber = '110';
						break;
					}
				}
			else
				$sErrorNumber = '103';
			}
		}
	else
		$sErrorNumber = '102';
	echo '<Error number="'.$sErrorNumber.'" originalDescription="'.ConvertToXmlAttribute( $sErrorMsg ).'" />';
	}

function FileUpload( $resourceType, $currentFolder, $sCommand ) {
	if ( ! isset( $_FILES ) ) global $_FILES;
	$sErrorNumber = '0';
	$sFileName = '';
	if ( isset( $_FILES['NewFile'] ) && ! is_null( $_FILES['NewFile']['tmp_name'] ) ) {
		global $Config;
		$oFile = $_FILES['NewFile'];
		$sServerDir = ServerMapFolder( $resourceType, $currentFolder, $sCommand );
		$sFileName = filemanager_translit( $oFile['name'] );
		$sFileName = SanitizeFileName( $sFileName );
		$sOriginalFileName = $sFileName;
		$sExtension = substr( $sFileName, ( strrpos( $sFileName, '.' ) + 1 ) );
		$sExtension = strtolower( $sExtension );
		if ( isset( $Config['SecureImageUploads'] ) ) {
			if ( ( $isImageValid = IsImageValid( $oFile['tmp_name'], $sExtension ) ) === false ) $sErrorNumber = '202';
			}
		if ( isset( $Config['HtmlExtensions'] ) ) {
			if ( ! IsHtmlExtension( $sExtension, $Config['HtmlExtensions'] ) && ( $detectHtml = DetectHtml( $oFile['tmp_name'] ) ) === true ) $sErrorNumber = '202';
			}
		if ( ! $sErrorNumber && IsAllowedExt( $sExtension, $resourceType ) ) {
			$iCounter = 0;
			while ( true ) {
				$sFilePath = $sServerDir.$sFileName;
				if ( is_file( $sFilePath ) ) {
					$iCounter++;
					$sFileName = RemoveExtension( $sOriginalFileName ).'('.$iCounter.').'.$sExtension;
					$sErrorNumber = '201';
					}
				else {
					move_uploaded_file( $oFile['tmp_name'], $sFilePath );
					if ( is_file( $sFilePath ) ) {
						if ( isset( $Config['ChmodOnUpload'] ) && ! $Config['ChmodOnUpload'] ) break;
						$permissions = 0777;
						if ( isset( $Config['ChmodOnUpload'] ) && $Config['ChmodOnUpload'] ) $permissions = $Config['ChmodOnUpload'];
						$oldumask = umask( 0 );
						chmod( $sFilePath, $permissions );
						umask( $oldumask );
						if ( $Config['ThumbCreate'] && $_POST['thumb'] && in_array( $sExtension, array( 'gif', 'jpg', 'jpeg', 'png', 'wbmp' ) ) ) filemanager_thumb( $sFilePath, $_POST['thumb_x'], $_POST['thumb_y'] );
						if ( $Config['ThumbList'] && $resourceType =='Image' ) {
							$sThumbPath = CombinePaths( $_SERVER['DOCUMENT_ROOT'].GetResourceTypePath( 'ImageThumb', 'Upload' ), filemanager_getthumbname( $currentFolder.$sFileName ) );
							filemanager_thumb( $sFilePath, $Config['ThumbListSize'], $Config['ThumbListSize'], $sThumbPath );
							}
						}
					break;
					}
				}
			if ( file_exists( $sFilePath ) ) {
				if ( isset( $isImageValid ) && $isImageValid === -1 && IsImageValid( $sFilePath, $sExtension ) === false ) {
					@unlink( $sFilePath );
					$sErrorNumber = '202';
					}
				elseif ( isset( $detectHtml ) && $detectHtml === -1 && DetectHtml( $sFilePath ) === true ) {
					@unlink( $sFilePath );
					$sErrorNumber = '202';
					}
				}
			}
		else
			$sErrorNumber = '202';
		}
	else
		$sErrorNumber = '202';
	$sFileUrl = CombinePaths( GetResourceTypePath( $resourceType, $sCommand ) , $currentFolder );
	$sFileUrl = CombinePaths( $sFileUrl, $sFileName );
	SendUploadResults( $sErrorNumber, $sFileUrl, $sFileName );
	exit(  );
	}

function FileDelete( $resourceType, $currentFolder, $Command ) {
	global $Config;
	if ( $resourceType =='Image' && $Config['ThumbList'] ) @unlink( CombinePaths( $_SERVER['DOCUMENT_ROOT'].GetResourceTypePath( 'ImageThumb', $Command ), filemanager_getthumbname( $currentFolder.$_GET['DelFile'] ) ) );
	$sServerDir = ServerMapFolder( $resourceType, $currentFolder, $Command );
	if ( ! unlink( $sServerDir.$_GET['DelFile'] ) ) echo '<Error number="1" originalDescription="Ошибка при удалении файла" />';
	}

function FolderDelete( $resourceType, $currentFolder, $Command ) {
	global $Config;
	$thumb = 1;
	$sServerDir = ServerMapFolder( $resourceType, $currentFolder, $Command );
	if ( ! filemanager_deldir( $_SERVER['DOCUMENT_ROOT'].GetResourceTypePath( $resourceType, 'Delete' ), $currentFolder.$_GET['DelFolder'].'/', $thumb ) || ! rmdir( $sServerDir.$_GET['DelFolder'].'/' ) ) echo '<Error number="1" originalDescription="Ошибка при удалении папки" />';
	}

function filemanager_dirsize( $dir,$size=0 ) {
	$hdl = opendir( $dir );
	while ( false !== ( $file = readdir( $hdl ) ) ) {
		if ( ( $file != "." ) && ($file != ".." ) ) {
			if ( is_dir( $dir."/".$file ) )
				return filemanager_dirsize( $dir."/".$file, $size );
			else
				$size += filesize( $dir."/".$file );
			}
		}
	closedir( $hdl );
	return filemanager_size( $size );
	}

function filemanager_size( $size ) {
	if ( $size < 1024 )
		return $size.' Б';
	elseif ( $size < 1048576 )
		return ceil( $size / 1024 )." КБ";
	else
		return round( $size / 1048576 )." МБ";
	}

function filemanager_translit( $input_string ) {
	$trans = array(  );
	$ch1 = "/\r\n-абвгдеёзийклмнопрстуфхцыэАБВГДЕЁЗИЙКЛМНОПРСТУФХЦЫЭABCDEFGHIJKLMNOPQRSTUVWXYZ";
	$ch2 = "    abvgdeeziyklmnoprstufhcyeabvgdeeziyklmnoprstufhcyeabcdefghijklmnopqrstuvwxyz";
	for ( $i = 0; $i < mb_strlen( $ch1 ); $i++ ) $trans[mb_substr( $ch1, $i, 1 )] = mb_substr( $ch2, $i, 1 );
	$trans["Ж"] = "zh";		$trans["ж"] = "zh";
	$trans["Ч"] = "ch";		$trans["ч"] = "ch";
	$trans["Ш"] = "sh";		$trans["ш"] = "sh";
	$trans["Щ"] = "sch";	$trans["щ"] = "sch";
	$trans["Ъ"] = "";		$trans["ъ"] = "";
	$trans["Ь"] = "";		$trans["ь"] = "";
	$trans["Ю"] = "yu";		$trans["ю"] = "yu";
	$trans["Я"] = "ya";		$trans["я"] = "ya";
	$trans["\\\\"] = " ";
	$trans["[^\. a-z0-9]"] = " ";
	$trans["^[ ]+|[ ]+$"] = "";
	$trans["[ ]+"] = "_";
	foreach( $trans as $from => $to ) $input_string = mb_ereg_replace( str_replace( "\\", "\\", $from ), $to, $input_string );
	return $input_string;
	}

function filemanager_deldir( $root, $del, $thumb = 0 ) {
	$cont = glob( CombinePaths( $root, $del )."*" );
	$rootLen = strlen( $root );
	$ok = 1;
	foreach ( $cont as $val ) {
		if ( is_dir( $val ) ) {
			$ok *= filemanager_deldir( $root, substr( $val, $rootLen-1 )."/", $thumb );
			$ok *= rmdir( $val ) ? 1 : 0;
			}
		else {
			$ok *= unlink( $val ) ? 1 : 0;
			if ( $thumb ) {
				$rootThumb = $_SERVER['DOCUMENT_ROOT'].GetResourceTypePath( 'ImageThumb', 'Delete' );
				@unlink( $rootThumb.filemanager_getthumbname( substr( $val, $rootLen-1 ) ) );
				}
			}
		}
	return $ok;
	}

function filemanager_thumb( $IMAGE_SOURCE, $THUMB_X, $THUMB_Y, $IMAGE_OUT = '' ) {
	list( $width, $height, $type, $attr ) = getimagesize( $IMAGE_SOURCE );
	switch( $type ) {
		case '1': $type_image = 'gif'; break;
		case '2': $type_image = 'jpg'; break;
		case '3': $type_image = 'png'; break;
		}
	if ( $THUMB_Y < 0 || $THUMB_X < 0 ) {
		$THUMB_CUT = 1;
		$THUMB_Y = (int)abs( $THUMB_Y );
		$THUMB_X = (int)abs( $THUMB_X );
		}
	else {
		$THUMB_CUT = 0;
		$THUMB_Y = (int)$THUMB_Y;
		$THUMB_X = (int)$THUMB_X;
		$SRC_W = $width;
		$SRC_H = $height;
		$SRC_L = 0;
		$SRC_T = 0;
		}
	if ( $THUMB_Y == 0 && $THUMB_X == 0 ) {
		$THUMB_Y = $height;
		$THUMB_X = $width;
		}
	elseif ( $THUMB_Y == 0 )
		$THUMB_Y = (int)( $height * ( $THUMB_X / $width ) );
	elseif ( $THUMB_X == 0 )
		$THUMB_X = (int)( $width * ( $THUMB_Y / $height ) );
	elseif ( $THUMB_CUT ) {
		$zoom_x = $width / $THUMB_X;
		$zoom_y = $height / $THUMB_Y;
		if ( $zoom_x <= $zoom_y ) {
			$SRC_W = $width;
			$SRC_H = (int)( $THUMB_Y * $zoom_x );
			$SRC_L = 0;
			$SRC_T = ( $height - $SRC_H ) / 2;
			}
		elseif ( $zoom_x > $zoom_y ) {
			$SRC_W = (int)( $THUMB_X * $zoom_y );
			$SRC_H = $height;
			$SRC_L = ( $width - $SRC_W ) / 2;
			$SRC_T = 0;
			}
		}
	else {
		$zoom_x = $width / $THUMB_X;
		$zoom_y = $height / $THUMB_Y;
		if ( $zoom_x >= $zoom_y )
			$THUMB_Y = (int)( $height * ( $THUMB_X / $width ) );
		elseif ( $zoom_x < $zoom_y )
			$THUMB_X = (int)( $width * ( $THUMB_Y / $height ) );
		}
	if ( $THUMB_X > $width && $THUMB_Y > $height ) {
		if ( $IMAGE_OUT != $IMAGE_SOURCE ) copy( $IMAGE_SOURCE, $IMAGE_OUT );
		return true;
		}
	$IMAGE_OUT = $IMAGE_OUT ? $IMAGE_OUT : $IMAGE_SOURCE;
	$filter = ( ( $SRC_L || $SRC_T ) ? '-crop '.$SRC_W.'x'.$SRC_H.'+'.$SRC_L.'+'.$SRC_T.'! ' : '' )."-resize ".$THUMB_X."x".$THUMB_Y;
	$thumb = imagecreatetruecolor( $THUMB_X, $THUMB_Y );
	switch ( $type_image ) {
		case 'jpg' : $source = @imagecreatefromJpeg( $IMAGE_SOURCE ); break;
		case 'png' : $source = @imagecreatefromPng( $IMAGE_SOURCE ); break;
		case 'gif' : $source = @imagecreatefromGif( $IMAGE_SOURCE ); break;
		}
	if ( $type_image == 'gif' || $type_image == 'png' ) {
		$white = imagecolorallocate( $thumb, 255, 255, 255 );
		imagefill( $thumb, 0, 0, $white );
		}
	imagecopyresized( $thumb, $source, 0, 0, 0, 0, $THUMB_X, $THUMB_Y, $SRC_W, $SRC_H );
	switch( $type_image ) {
		case 'jpg':
			imagejpeg( $thumb, $IMAGE_OUT, 85 );
		case 'png':
			imagepng( $thumb, $IMAGE_OUT );
		case 'gif':
			imagegif( $thumb, $IMAGE_OUT );
		}
	imagedestroy( $thumb );
	}

function filemanager_getthumbname( $path ) {
	if ( substr( $path, 0, 1 ) == '/' ) $path = substr( $path, 1 );
	return str_replace( '/', '_-_', $path );
	}
?>